"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _File_lastModified, _File_name;
Object.defineProperty(exports, "__esModule", { value: true });
exports.File = void 0;
const index_js_1 = __importDefault(require("./index.js"));
const _File = class File extends index_js_1.default {
    /**
     * @param {*[]} fileBits
     * @param {string} fileName
     * @param {{lastModified?: number, type?: string}} options
     */ // @ts-ignore
    constructor(fileBits, fileName, options = {}) {
        if (arguments.length < 2) {
            throw new TypeError(`Failed to construct 'File': 2 arguments required, but only ${arguments.length} present.`);
        }
        super(fileBits, options);
        _File_lastModified.set(this, 0);
        _File_name.set(this, '');
        if (options === null)
            options = {};
        const modified = Number(options.lastModified);
        __classPrivateFieldSet(this, _File_lastModified, Number.isNaN(modified) ? Date.now() : modified, "f");
        __classPrivateFieldSet(this, _File_name, String(fileName), "f");
    }
    get name() {
        return __classPrivateFieldGet(this, _File_name, "f");
    }
    get lastModified() {
        return __classPrivateFieldGet(this, _File_lastModified, "f");
    }
    get [(_File_lastModified = new WeakMap(), _File_name = new WeakMap(), Symbol.toStringTag)]() {
        return "File";
    }
};
/** @type {typeof globalThis.File} */ // @ts-ignore
exports.File = _File;
exports.default = exports.File;
