"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const stream_1 = require("stream");
const buffer_1 = __importDefault(require("buffer"));
const ava_1 = __importDefault(require("ava"));
const node_fetch_1 = require("node-fetch");
const from_js_1 = __importStar(require("./from.js"));
const file_js_1 = __importDefault(require("./file.js"));
const index_js_1 = __importDefault(require("./index.js"));
const license = fs_1.default.readFileSync('./LICENSE', 'utf-8');
(0, ava_1.default)('new Blob()', t => {
    const blob = new index_js_1.default(); // eslint-disable-line no-unused-vars
    t.pass();
});
(0, ava_1.default)('new Blob(parts)', t => {
    const data = 'a=1';
    const blob = new index_js_1.default([data]); // eslint-disable-line no-unused-vars
    t.pass();
});
(0, ava_1.default)('Blob ctor parts', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const parts = [
        'a',
        new Uint8Array([98]),
        new Uint16Array([25699]),
        new Uint8Array([101]).buffer,
        Buffer.from('f'),
        new index_js_1.default(['g']),
        {},
        new URLSearchParams('foo')
    ];
    const blob = new index_js_1.default(parts);
    t.is(yield blob.text(), 'abcdefg[object Object]foo=');
}));
(0, ava_1.default)('Blob ctor threats an object with @@iterator as a sequence', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const blob = new index_js_1.default({ [Symbol.iterator]: Array.prototype[Symbol.iterator] });
    t.is(blob.size, 0);
    t.is(yield blob.text(), '');
}));
(0, ava_1.default)('Blob ctor reads blob parts from object with @@iterator', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const input = ['one', 'two', 'three'];
    const expected = input.join('');
    const blob = new index_js_1.default({
        *[Symbol.iterator]() {
            yield* input;
        }
    });
    t.is(blob.size, new TextEncoder().encode(expected).byteLength);
    t.is(yield blob.text(), expected);
}));
(0, ava_1.default)('Blob ctor throws a string', t => {
    t.throws(() => new index_js_1.default('abc'));
});
(0, ava_1.default)('Blob ctor threats Uint8Array as a sequence', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const input = [1, 2, 3];
    const blob = new index_js_1.default(new Uint8Array(input));
    t.is(yield blob.text(), input.join(''));
}));
(0, ava_1.default)('Blob size', t => {
    const data = 'a=1';
    const blob = new index_js_1.default([data]);
    t.is(blob.size, data.length);
});
(0, ava_1.default)('Blob type', t => {
    const type = 'text/plain';
    const blob = new index_js_1.default([], { type });
    t.is(blob.type, type);
});
(0, ava_1.default)('Blob slice type', t => {
    const type = 'text/plain';
    const blob = new index_js_1.default().slice(0, 0, type);
    t.is(blob.type, type);
});
(0, ava_1.default)('invalid Blob type', t => {
    const blob = new index_js_1.default([], { type: '\u001Ftext/plain' });
    t.is(blob.type, '');
});
(0, ava_1.default)('invalid Blob slice type', t => {
    const blob = new index_js_1.default().slice(0, 0, '\u001Ftext/plain');
    t.is(blob.type, '');
});
(0, ava_1.default)('Blob text()', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const data = 'a=1';
    const type = 'text/plain';
    const blob = new index_js_1.default([data], { type });
    t.is(yield blob.text(), data);
}));
(0, ava_1.default)('Blob arrayBuffer()', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const data = 'a=1';
    const type = 'text/plain';
    const blob = new index_js_1.default([data], { type });
    const decoder = new TextDecoder('utf-8');
    const buffer = yield blob.arrayBuffer();
    t.is(decoder.decode(buffer), data);
}));
(0, ava_1.default)('Blob stream()', (t) => __awaiter(void 0, void 0, void 0, function* () {
    var e_1, _a;
    const data = 'a=1';
    const type = 'text/plain';
    const blob = new index_js_1.default([data], { type });
    try {
        for (var _b = __asyncValues(blob.stream()), _c; _c = yield _b.next(), !_c.done;) {
            const chunk = _c.value;
            t.is(chunk.join(), [97, 61, 49].join());
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) yield _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
}));
(0, ava_1.default)('Blob toString()', t => {
    const data = 'a=1';
    const type = 'text/plain';
    const blob = new index_js_1.default([data], { type });
    t.is(blob.toString(), '[object Blob]');
});
(0, ava_1.default)('Blob slice()', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const data = 'abcdefgh';
    const blob = new index_js_1.default([data]).slice();
    t.is(yield blob.text(), data);
}));
(0, ava_1.default)('Blob slice(0, 1)', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const data = 'abcdefgh';
    const blob = new index_js_1.default([data]).slice(0, 1);
    t.is(yield blob.text(), 'a');
}));
(0, ava_1.default)('Blob slice(-1)', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const data = 'abcdefgh';
    const blob = new index_js_1.default([data]).slice(-1);
    t.is(yield blob.text(), 'h');
}));
(0, ava_1.default)('Blob slice(0, -1)', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const data = 'abcdefgh';
    const blob = new index_js_1.default([data]).slice(0, -1);
    t.is(yield blob.text(), 'abcdefg');
}));
(0, ava_1.default)('Blob(["hello ", "world"]).slice(5)', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const parts = ['hello ', 'world'];
    const blob = new index_js_1.default(parts);
    t.is(yield blob.slice(5).text(), ' world');
}));
(0, ava_1.default)('throw away unwanted parts', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const blob = new index_js_1.default(['a', 'b', 'c']).slice(1, 2);
    t.is(yield blob.text(), 'b');
}));
(0, ava_1.default)('Blob works with node-fetch Response.blob()', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const data = 'a=1';
    const type = 'text/plain';
    const blob = new index_js_1.default([data], { type });
    const response = new node_fetch_1.Response(stream_1.Readable.from(blob.stream()));
    const blob2 = yield response.blob();
    t.is(yield blob2.text(), data);
}));
(0, ava_1.default)('Blob works with node-fetch Response.text()', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const data = 'a=1';
    const type = 'text/plain';
    const blob = new index_js_1.default([data], { type });
    const response = new node_fetch_1.Response(stream_1.Readable.from(blob.stream()));
    const text = yield response.text();
    t.is(text, data);
}));
(0, ava_1.default)('blob part backed up by filesystem', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const blob = (0, from_js_1.blobFromSync)('./LICENSE');
    t.is(yield blob.slice(0, 3).text(), license.slice(0, 3));
    t.is(yield blob.slice(4, 11).text(), license.slice(4, 11));
}));
(0, ava_1.default)('Reading after modified should fail', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const blob = (0, from_js_1.blobFromSync)('./LICENSE');
    yield new Promise(resolve => {
        setTimeout(resolve, 500);
    });
    fs_1.default.closeSync(fs_1.default.openSync('./LICENSE', 'a'));
    const error = yield t.throwsAsync(blob.text());
    t.is(error.constructor.name, 'DOMException');
    t.is(error instanceof Error, true);
    t.is(error.name, 'NotReadableError');
    const file = (0, from_js_1.fileFromSync)('./LICENSE');
    // Above test updates the last modified date to now
    t.is(typeof file.lastModified, 'number');
    // The lastModifiedDate is deprecated and removed from spec
    t.false('lastModifiedDate' in file);
    const mod = file.lastModified - Date.now();
    t.true(mod <= 0 && mod >= -500); // Close to tolerance: 0.500ms
}));
(0, ava_1.default)('Reading file after modified should fail', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const file = (0, from_js_1.fileFromSync)('./LICENSE');
    yield new Promise(resolve => {
        setTimeout(resolve, 100);
    });
    const now = new Date();
    // Change modified time
    fs_1.default.utimesSync('./LICENSE', now, now);
    const error = yield t.throwsAsync(file.text());
    t.is(error.constructor.name, 'DOMException');
    t.is(error instanceof Error, true);
    t.is(error.name, 'NotReadableError');
}));
(0, ava_1.default)('Reading from the stream created by blobFrom', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const blob = (0, from_js_1.blobFromSync)('./LICENSE');
    const actual = yield blob.text();
    t.is(actual, license);
}));
(0, ava_1.default)('create a blob from path asynchronous', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const blob = yield (0, from_js_1.blobFrom)('./LICENSE');
    const actual = yield blob.text();
    t.is(actual, license);
}));
(0, ava_1.default)('Reading empty blobs', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const blob = (0, from_js_1.blobFromSync)('./LICENSE').slice(0, 0);
    const actual = yield blob.text();
    t.is(actual, '');
}));
(0, ava_1.default)('Blob-ish class is an instance of Blob', t => {
    class File {
        stream() { }
        get [Symbol.toStringTag]() {
            return 'File';
        }
    }
    t.true(new File() instanceof index_js_1.default);
});
(0, ava_1.default)('Instanceof check returns false for nullish values', t => {
    t.false(null instanceof index_js_1.default);
});
/** @see https://github.com/w3c/FileAPI/issues/43 - important to keep boundary value */
(0, ava_1.default)('Dose not lowercase the blob values', t => {
    const type = 'multipart/form-data; boundary=----WebKitFormBoundaryTKqdrVt01qOBltBd';
    t.is(new index_js_1.default([], { type }).type, type);
});
(0, ava_1.default)('Parts are immutable', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const buf = new Uint8Array([97]);
    const blob = new index_js_1.default([buf]);
    buf[0] = 98;
    t.is(yield blob.text(), 'a');
}));
(0, ava_1.default)('Blobs are immutable', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const buf = new Uint8Array([97]);
    const blob = new index_js_1.default([buf]);
    const chunk = yield blob.stream().getReader().read();
    t.is(chunk.value[0], 97);
    chunk.value[0] = 98;
    t.is(yield blob.text(), 'a');
}));
// This was necessary to avoid large ArrayBuffer clones (slice)
(0, ava_1.default)('Large chunks are divided into smaller chunks', (t) => __awaiter(void 0, void 0, void 0, function* () {
    var e_2, _d;
    const buf = new Uint8Array(65590);
    const blob = new index_js_1.default([buf]);
    let i = 0;
    try {
        // eslint-disable-next-line no-unused-vars
        for (var _e = __asyncValues(blob.stream()), _f; _f = yield _e.next(), !_f.done;) {
            const chunk = _f.value;
            i++;
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_f && !_f.done && (_d = _e.return)) yield _d.call(_e);
        }
        finally { if (e_2) throw e_2.error; }
    }
    t.is(i === 2, true);
}));
(0, ava_1.default)('Can use named import - as well as default', (t) => __awaiter(void 0, void 0, void 0, function* () {
    // eslint-disable-next-line node/no-unsupported-features/es-syntax
    const { Blob, default: def } = yield Promise.resolve().then(() => __importStar(require('./index.js')));
    t.is(Blob, def);
}));
(0, ava_1.default)('default from.js exports blobFromSync', t => {
    t.is(from_js_1.blobFromSync, from_js_1.default);
});
if (buffer_1.default.Blob) {
    (0, ava_1.default)('Can wrap buffer.Blob to a fetch-blob', (t) => __awaiter(void 0, void 0, void 0, function* () {
        const blob1 = new buffer_1.default.Blob(['blob part']);
        const blob2 = new index_js_1.default([blob1]);
        t.is(yield blob2.text(), 'blob part');
    }));
}
(0, ava_1.default)('File is a instance of blob', t => {
    t.true(new file_js_1.default([], '') instanceof index_js_1.default);
});
(0, ava_1.default)('fileFrom returns the name', (t) => __awaiter(void 0, void 0, void 0, function* () {
    t.is((yield (0, from_js_1.fileFrom)('./LICENSE')).name, 'LICENSE');
}));
(0, ava_1.default)('fileFromSync returns the name', t => {
    t.is((0, from_js_1.fileFromSync)('./LICENSE').name, 'LICENSE');
});
(0, ava_1.default)('fileFromSync(path, type) sets the type', t => {
    t.is((0, from_js_1.fileFromSync)('./LICENSE', 'text/plain').type, 'text/plain');
});
(0, ava_1.default)('blobFromSync(path, type) sets the type', t => {
    t.is((0, from_js_1.blobFromSync)('./LICENSE', 'text/plain').type, 'text/plain');
});
(0, ava_1.default)('fileFrom(path, type) sets the type', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const file = yield (0, from_js_1.fileFrom)('./LICENSE', 'text/plain');
    t.is(file.type, 'text/plain');
}));
(0, ava_1.default)('new File(,,{lastModified: 100})', t => {
    const mod = new file_js_1.default([], '', { lastModified: 100 }).lastModified;
    t.is(mod, 100);
});
(0, ava_1.default)('new File(,,{lastModified: "200"})', t => {
    const mod = new file_js_1.default([], '', { lastModified: '200' }).lastModified;
    t.is(mod, 200);
});
(0, ava_1.default)('new File(,,{lastModified: true})', t => {
    const mod = new file_js_1.default([], '', { lastModified: true }).lastModified;
    t.is(mod, 1);
});
(0, ava_1.default)('new File(,,{lastModified: new Date()})', t => {
    const mod = new file_js_1.default([], '', { lastModified: new Date() }).lastModified - Date.now();
    t.true(mod <= 0 && mod >= -20); // Close to tolerance: 0.020ms
});
(0, ava_1.default)('new File(,,{}) sets current time', t => {
    const mod = new file_js_1.default([], '').lastModified - Date.now();
    t.true(mod <= 0 && mod >= -20); // Close to tolerance: 0.020ms
});
(0, ava_1.default)('blobFrom(path, type) sets the type', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const blob = yield (0, from_js_1.blobFrom)('./LICENSE', 'text/plain');
    t.is(blob.type, 'text/plain');
}));
(0, ava_1.default)('blobFrom(path) sets empty type', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const blob = yield (0, from_js_1.blobFrom)('./LICENSE');
    t.is(blob.type, '');
}));
(0, ava_1.default)('new File() throws with too few args', t => {
    t.throws(() => new file_js_1.default(), {
        instanceOf: TypeError,
        message: 'Failed to construct \'File\': 2 arguments required, but only 0 present.'
    });
});
(0, ava_1.default)('can slice zero sized blobs', (t) => __awaiter(void 0, void 0, void 0, function* () {
    const blob = new index_js_1.default();
    const txt = yield blob.slice(0, 0).text();
    t.is(txt, '');
}));
(0, ava_1.default)('returns a readable stream', t => {
    const stream = new file_js_1.default([], '').stream();
    t.true(typeof stream.getReader === 'function');
});
(0, ava_1.default)('checking instanceof blob#stream', (t) => __awaiter(void 0, void 0, void 0, function* () {
    // eslint-disable-next-line node/no-unsupported-features/es-syntax
    const { ReadableStream } = yield Promise.resolve().then(() => __importStar(require('stream/web'))).catch(_ => Promise.resolve().then(() => __importStar(require('web-streams-polyfill/dist/ponyfill.es2018.js'))));
    const stream = new file_js_1.default([], '').stream();
    t.true(stream instanceof ReadableStream);
}));
